<?php
/*
** Zabbix
** Copyright (C) 2001-2018 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/
require_once dirname(__FILE__).'/include/config.inc.php';
phpCAS::setVerbose(true);

//打印日志
//phpCAS::setDebug('/tmp/cas_php_log');
phpCAS::client(CAS_VERSION_3_0, $SSO_SERVER_DOMAIN, $SSO_SERVER_PORT, $SSO_SERVER_URI);

// close ssl val 不验证证书
phpCAS::setNoCasServerValidation();

// handle incoming logout requests
phpCAS::handleLogoutRequests(false);

// force CAS authentication
phpCAS::forceAuthentication();

if(phpCAS::isAuthenticated()){

    $alias = phpCAS::getUser();
    $ssoInfo = phpCAS::getAttributes();
    //$zbx_sessionid = !empty($_COOKIE['zbx_sessionid']) ? $_COOKIE['zbx_sessionid'] : null;
    $zbx_sessionid =  null;
    $userAuth = API::User()->checkAuthentication(['sessionid' => $zbx_sessionid]);

    if(empty($userAuth) || $userAuth['alias'] == ZBX_GUEST_USER || empty($userAuth['alias'])){

        //模拟登录
        $userInfo = DBfetch(DBselect(
            'SELECT u.userid,u.attempt_failed,u.attempt_clock,u.attempt_ip'.
            ' FROM users u'.
            ' WHERE u.alias='.zbx_dbstr($alias)
        ));

        $password = md5($ssoInfo['id'].$ssoInfo['account'].$SALT,false);
        //$usergrpid = $ZBX_USER_SSO_GROUP_ID;

        $name = empty($ssoInfo['name']) ? '' : $ssoInfo['name'];
        $email = empty($ssoInfo['email']) ? '' : $ssoInfo['email'];
        $mobile = empty($ssoInfo['mobile']) ? '' : $ssoInfo['mobile'];
        $weixin = empty($ssoInfo['weixin']) ? '' : $ssoInfo['weixin'];
        $dingding = empty($ssoInfo['dingding']) ? '' : $ssoInfo['dingding'];

        //打印日志
        //@file_put_contents(dirname(__FILE__) . '/log/log_'.date("Y-m-d").'.log', date("Y-m-d H:i:s") . "\t" . json_encode($ssoInfo, JSON_UNESCAPED_UNICODE) . "\n", FILE_APPEND);

        //@file_put_contents(dirname(__FILE__) . '/log/log_'.date("Y-m-d").'.log', date("Y-m-d H:i:s") . "\t" . "INSERT INTO users (userid, alias, `name`, `passwd`,surname,url,autologin,autologout,lang,refresh,type,theme,attempt_failed,attempt_ip,attempt_clock,rows_per_page) VALUES ('{$userid}','{$alias}', '{$name}', '{$password}','','',0,0,'en_GB','30',1,'default',0,'0.0.0.0',0,50)" . "\n", FILE_APPEND);

        //关闭Guests用户组
        DBexecute("UPDATE usrgrp set users_status = '1', gui_access = '3',debug_mode = '0' WHERE name = 'Guests'");

        //如果是新用户，就添加用户到数据库并添加到Guests用户组
        if($ssoInfo){
            //$is_new_user = false;
            if(!$userInfo){
                $userid = getUserID();
                //添加新用户到数据库
                DBexecute("INSERT INTO users (userid, alias, `name`, `passwd`,surname,url,autologin,autologout,lang,refresh,type,theme,attempt_failed,attempt_ip,attempt_clock,rows_per_page) VALUES ('{$userid}','{$alias}','{$name}','{$password}','','',0,0,'en_GB','30s',1,'default',0,'0.0.0.0',0,50)");
                
                $userInfo = DBfetch(DBselect(
                    'SELECT u.userid,u.attempt_failed,u.attempt_clock,u.attempt_ip'.
                    ' FROM users u'.
                    ' WHERE u.alias='.zbx_dbstr($alias)
                ));
           
                //把新用户放到Guest组
                $groupid = getUserGroupID();
                $usrgrpidInfo = DBfetch(DBselect("SELECT usrgrpid FROM usrgrp WHERE name = 'Guests'"));
                $usrgrpid = $usrgrpidInfo['usrgrpid'];
                $userid = $userInfo['userid'];
                DBexecute("INSERT INTO users_groups (id, usrgrpid, userid) VALUES ('{$groupid}','{$usrgrpid}','{$userid}')");
                echo $ERR_PAGE_HTML;
                exit();
                //$is_new_user = true; 
            }else{
                $userid = $userInfo['userid'];
                //检查用户是否在Disable组，如果在就退出
                $userDisabledGroup = DBfetch(DBselect("SELECT users_groups.usrgrpid,users_groups.userid,usrgrp.users_status FROM users_groups 
                LEFT JOIN usrgrp ON users_groups.usrgrpid = usrgrp.usrgrpid
                WHERE usrgrp.users_status = 1 AND users_groups.userid = '{$userid}'"));
                //如果存在就报错并退出
                if($userDisabledGroup){
                    echo $ERR_PAGE_HTML;
                    exit();
                }

                //登录用户是admin登录，判断media_type是否存在email、mobile、weixin、dingding，不存在就创建
                $_type_value = "";
                if($alias == 'admin'){
                    $_type_value = ", type='3' ";
                    checkMediaType();
                }

                //更新用户密码
                $_update_user_sql = "UPDATE users set `name`='{$name}', `passwd` = '{$password}' {$_type_value} WHERE alias = '{$alias}'";
                DBexecute($_update_user_sql);
            }
        }

        $mediaInfo = getMediaInfo();
        
        //更新用户media
        foreach($mediaInfo as $key => $media){
            switch($key){
                case 'email':
                    $sendto = $email;
                    break;
                case 'mobile':
                    $sendto = $mobile;
                    break;
                case 'weixin':
                    $sendto = $weixin;
                    break;
                case 'dingding':
                    $sendto = $dingding;
                    break;
            }
            $userMedia = DBfetch(DBselect("SELECT `mediaid` FROM media WHERE `userid`='{$userid}' AND `mediatypeid` = '{$media}'"));
            if(empty($userMedia['mediaid'])){
                $mediaid = getMediaID();
                //insert
                $mediaSql = "INSERT INTO media (mediaid, userid, mediatypeid, sendto, active, severity, period) VALUES ('{$mediaid}', '{$userid}', '{$media}', '{$sendto}',0,63,'1-7,00:00-24:00')";
            }else{
                //update
                $mediaSql = "UPDATE media SET sendto='{$sendto}', severity='63' WHERE `mediaid` = '{$userMedia['mediaid']}'";
            }
            # 判断如果media数据不为空的时候执行sql,否则不执行
            if(!empty($sendto)){
                DBexecute($mediaSql);
            }
        }
        //end media

        if ($userInfo['attempt_failed'] >= ZBX_LOGIN_ATTEMPTS) {
            DBexecute('UPDATE users SET attempt_clock='.time().' WHERE alias='.zbx_dbstr($alias));
        }

        $sessionid = md5(time().$alias.rand(0, 10000000));
        DBexecute('INSERT INTO sessions (sessionid,userid,lastaccess,status)'.
            ' VALUES ('.zbx_dbstr($sessionid).','.zbx_dbstr($userInfo['userid']).','.time().','.ZBX_SESSION_ACTIVE.')'
        );
        CWebUser::$data = API::User()->login([
            'user' => $alias,
            'password' => $sessionid,
            'userData' => true
        ]);
        CWebUser::setSessionCookie($sessionid);
        //var_dump(1);exit();
        if(API::User()->checkAuthentication(['sessionid' => $sessionid])){
            $goto_url = buildGotoUrl();
            header("Location: " . $goto_url);
        }else{
            gotoSSO();
        }
    }else{
        //API::User()->checkAuthentication(['sessionid' => $zbx_sessionid]);
        if(API::User()->checkAuthentication(['sessionid' => $zbx_sessionid])){
            $goto_url = buildGotoUrl();
            header("Location: " . $goto_url);
        }else{
            gotoSSO();
        }
    }

    if(isset($_REQUEST['logout']) && $_REQUEST['logout']){
        //CWebUser::setSessionCookie('');
        CWebUser::logout();
        session_destroy();
        //@file_put_contents(dirname(__FILE__) . '/log/log_'.date("Y-m-d").'.log', date("Y-m-d H:i:s") . "\t" . '[POST]' . "\t" . json_encode($_POST, JSON_UNESCAPED_UNICODE) . "\n", FILE_APPEND);
        $goto_url = empty($_REQUEST['request']) ? '' : ($_REQUEST['request']);
        phpCAS::logout(['service'=> ($CLIENT_SSO_URL . '?request=' .  $goto_url)]);
    }
}else{
    echo 'auth error!';
    exit();
}


function getUserID(){
    $maxid = DBfetch(DBselect("SELECT max(userid) AS id FROM users"));
    return intval($maxid['id']) + 1;
}

function getUserGroupID(){
    $maxid = DBfetch(DBselect("SELECT max(id) AS id FROM users_groups"));
    return intval($maxid['id']) + 1;
}

function getMediaID(){
    $maxid = DBfetch(DBselect("SELECT max(mediaid) AS id FROM media"));
    return intval($maxid['id']) + 1;
}

//email mobile weixin dingding mediatypeid
function getMediaInfo(){
    $media = DBfetchArray(DBselect("SELECT mediatypeid,description FROM media_type WHERE description = 'email' OR description = 'mobile' OR description = 'weixin' OR description = 'dingding'"));
    $mediaInfo = array();
    if(is_array($media)){
        foreach ($media as $item){
            if($item['description'] == 'email'){
                $mediaInfo['email'] = $item['mediatypeid'];
            }
            if($item['description'] == 'mobile'){
                $mediaInfo['mobile'] = $item['mediatypeid'];
            }
            if($item['description'] == 'weixin'){
                $mediaInfo['weixin'] = $item['mediatypeid'];
            }
            if($item['description'] == 'dingding'){
                $mediaInfo['dingding'] = $item['mediatypeid'];
            }
        }
    }
    return $mediaInfo;
}

function checkMediaType(){
    $info = DBfetchArray(DBselect("SELECT * FROM media_type WHERE description = 'email' OR description = 'mobile' OR description = 'weixin' OR description = 'dingding'"));
    $hasemail = $hasmobile = $hasweixin = $hasdingding = false;
    if(is_array($info)){
        foreach($info as $item){
            if($item['description'] == 'email'){
                $hasemail = true;
            }
            if($item['description'] == 'mobile'){
                $hasmobile = true;
            }
            if($item['description'] == 'weixin'){
                $hasweixin = true;
            }
            if($item['description'] == 'dingding'){
                $hasdingding = true;
            }
        }
    }
 
     $data = array (
        'mediatypeid' => '',
        'type' => '',
        'description' => '',
        'smtp_server' => '',
        'smtp_helo' => '',
        'smtp_email' => '',
        'exec_path' => '',
        'gsm_modem' => '',
        'username' => '',
        'passwd' => '',
        'status' => '0',
        'smtp_port' => '25',
        'smtp_security' => '0',
        'smtp_verify_peer' => '0',
        'smtp_verify_host' => '0',
        'smtp_authentication' => '0',
        'exec_params' => '',
        'maxsessions' => '1',
        'maxattempts' => '3',
        'attempt_interval' => '10s',
    );

    if(!$hasemail){
        $email = $data;
        $email['mediatypeid'] = getMediaTypeID();
        $email['type'] = '0';
        $email['description'] = 'email';
        $email['smtp_server'] = 'localhost';
        $email['smtp_helo'] = 'localhost';
        $email['smtp_email'] = 'zabbix@localhost';
        $email['smtp_port'] = '25';
        $email_sql = mdSql($email);
        DBexecute($email_sql);
    }

    if(!$hasmobile){
        $mobile = $data;
        $mobile['mediatypeid'] = getMediaTypeID();
        $mobile['type'] = '1';
        $mobile['description'] = 'mobile';
        $mobile['exec_path'] = 'mobile.sh';
        $mobile_sql = mdSql($mobile);
        DBexecute($mobile_sql);
    }

    if(!$hasweixin){
        $weixin = $data;
        $weixin['mediatypeid'] = getMediaTypeID();
        $weixin['type'] = '1';
        $weixin['description'] = 'weixin';
        $weixin['exec_path'] = 'weixin.sh';
        $weixin_sql = mdSql($weixin);
        DBexecute($weixin_sql);
    }
    
    if(!$hasdingding){
        $dingding = $data;
        $dingding['mediatypeid'] = getMediaTypeID();
        $dingding['type'] = '1';
        $dingding['description'] = 'dingding';
        $dingding['exec_path'] = 'dingding.sh';
        $dingding_sql = mdSql($dingding);
        DBexecute($dingding_sql);
    }
}

function mdSql($data, $table = 'media_type'){
     $sql = "INSERT INTO {$table} ";
     $fields = $values = [];
     foreach ($data as $key => $item){
         $fields[] = $key;
         $values[] = $item;
    }
    $sql .= '(`' . implode('`,`', $fields) . '`)';
    $sql .= " VALUES ";
    $sql .= '(\'' . implode('\',\'', $values) . '\')';
    return $sql;
    }

function getMediaTypeID(){
    $maxid = DBfetch(DBselect("SELECT max(mediatypeid) AS id FROM media_type"));
    return intval($maxid['id']) + 1;
}

//构建跳转return string
function buildGotoUrl(){
    $goto_url = empty($_REQUEST['request']) ? '/' : ('/' . $_REQUEST['request']);
    # JasonLee mod: 兼容各种参数
    # 理想状态是 sso 跳转回zabbix sso.php的时候 urlencode 没有urlencode 只能用这种方式
    if(is_array($_REQUEST) && $goto_url != '/'){
        foreach($_REQUEST as $key=>$val){
            if($key != 'request'){
                $goto_url .= '&' . $key . '=' . $val;
            }
        }
    }
    return $goto_url;
}

